/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20160212-64
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt5.dat, Sat Aug 13 18:53:35 2016
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000005CF (1487)
 *     Revision         0x02
 *     Checksum         0xE2
 *     OEM ID           "SgRef"
 *     OEM Table ID     "SgPch"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20120913 (538052883)
 */
DefinitionBlock ("ssdt5.aml", "SSDT", 2, "SgRef", "SgPch", 0x00001000)
{

    External (_SB_.GGOV, IntObj)
    External (_SB_.PCI0.LPCB.H_EC.OPST, UnknownObj)
    External (_SB_.PCI0.RP01, DeviceObj)
    External (_SB_.PCI0.RP01._ADR, UnknownObj)
    External (_SB_.SGOV, MethodObj)    // 2 Arguments
    External (DLHR, UnknownObj)
    External (DLPW, UnknownObj)
    External (EBAS, MethodObj)    // 1 Arguments
    External (ECON, UnknownObj)
    External (EECP, MethodObj)    // 1 Arguments
    External (GPRW, IntObj)
    External (HRA0, UnknownObj)
    External (HRE0, UnknownObj)
    External (HRG0, UnknownObj)
    External (HYSS, IntObj)
    External (LTRE, IntObj)
    External (OSYS, UnknownObj)
    External (PWA0, UnknownObj)
    External (PWE0, UnknownObj)
    External (PWG0, UnknownObj)
    External (RPA1, UnknownObj)
    External (SGGP, UnknownObj)
    External (SGMD, UnknownObj)
    External (XBAS, UnknownObj)

    Scope (\_SB.PCI0.RP01)
    {
        OperationRegion (MSID, SystemMemory, EBAS (0x0500), Field (MSID, DWordAcc, Lock, Preserve)
            {
                VEID,   16, 
                Offset (0x40), 
                NVID,   32, 
                Offset (0x4C), 
                ATID,   32, 
                Offset (0x48B), 
                    ,   1, 
                NHDA,   1
            })
        OperationRegion (RPCX, SystemMemory, ((\XBAS + (((\_SB.PCI0.RP01._ADR & 0x00FF0000) >> 0x10) << 
            0x0F)) + ((\RPA1 & 0x0F) << 0x0C)), 0x1000)
        Field (RPCX, DWordAcc, NoLock, Preserve)
        {
            PVID,   16, 
            PDID,   16, 
            CMDR,   8, 
            Offset (0x19), 
            PRBN,   8, 
            SCBN,   8, 
            Offset (0x4A), 
            CEDR,   1, 
            Offset (0x50), 
            ASPM,   2, 
                ,   2, 
            LNKD,   1, 
            Offset (0x69), 
                ,   2, 
            LREN,   1, 
            Offset (0xA4), 
            D0ST,   2, 
            Offset (0x328), 
                ,   19, 
            LNKS,   4
        }

        Mutex (OMUT, 0x00)
        PowerResource (PC01, 0x00, 0x0000)
        {
            Name (_STA, One)  // _STA: Status
            Method (_ON, 0, Serialized)  // _ON_: Power On
            {
                Acquire (OMUT, 0xFFFF)
                If ((OSYS != 0x07D9))
                {
                    \_SB.PCI0.RP01.PEGP.HGON ()
                    CMDR |= 0x07
                    D0ST = Zero
                    If ((VEID == 0x10DE))
                    {
                        NVID = HYSS /* External reference */
                        NHDA = Zero
                    }

                    If ((VEID == 0x1002))
                    {
                        ATID = HYSS /* External reference */
                    }

                    _STA = One
                    If ((\ECON == One))
                    {
                        \_SB.PCI0.LPCB.H_EC.OPST = One
                    }

                    Release (OMUT)
                }
            }

            Method (_OFF, 0, Serialized)  // _OFF: Power Off
            {
                Acquire (OMUT, 0xFFFF)
                If ((OSYS != 0x07D9))
                {
                    \_SB.PCI0.RP01.PEGP.HGOF ()
                    _STA = Zero
                    If ((\ECON == One))
                    {
                        \_SB.PCI0.LPCB.H_EC.OPST = Zero
                    }

                    Release (OMUT)
                }
            }
        }

        Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
        {
            PC01
        })
        Name (_PR2, Package (0x01)  // _PR2: Power Resources for D2
        {
            PC01
        })
        Name (_PR3, Package (0x01)  // _PR3: Power Resources for D3hot
        {
            PC01
        })
        Method (_S0W, 0, NotSerialized)  // _S0W: S0 Device Wake State
        {
            Return (0x04)
        }

        Device (PEGP)
        {
            Name (_ADR, Zero)  // _ADR: Address
            Method (_PRW, 0, NotSerialized)  // _PRW: Power Resources for Wake
            {
                Return (GPRW) /* External reference */
                0x69
                0x04
            }
        }

        Device (PEGA)
        {
            Name (_ADR, One)  // _ADR: Address
            OperationRegion (ACAP, PCI_Config, \EECP (0x14), Field (ACAP, DWordAcc, NoLock, Preserve)
                {
                    Offset (0x10), 
                    LCT1,   16
                })
            Method (_PRW, 0, NotSerialized)  // _PRW: Power Resources for Wake
            {
                Return (GPRW) /* External reference */
                0x69
                0x04
            }
        }
    }

    Scope (\_SB.PCI0.RP01.PEGP)
    {
        Name (IVID, 0xFFFF)
        Name (ELCT, Zero)
        Name (HVID, Zero)
        Name (HDID, Zero)
        Name (TCNT, Zero)
        Name (LDLY, 0x64)
        OperationRegion (PCIS, SystemMemory, (\XBAS + (PRBN << 0x14)), 0xF0)
        Field (PCIS, AnyAcc, Lock, Preserve)
        {
            DVID,   16, 
            Offset (0x0B), 
            CBCC,   8, 
            Offset (0x2C), 
            SVID,   16, 
            SDID,   16
        }

        OperationRegion (PCAP, SystemMemory, 0x14 = ((\XBAS + (PRBN << 0x14)) + \EECP (Zero)), 
            Field (PCAP, DWordAcc, NoLock, Preserve)
            {
                Offset (0x10), 
                LCTL,   16
            })
        Method (_INI, 0, NotSerialized)  // _INI: Initialize
        {
            \_SB.PCI0.RP01.PEGP._ADR = Zero
        }

        Method (HGON, 0, Serialized)
        {
            If ((SGGP != One))
            {
                Return (Zero)
            }

            If ((CCHK (One) == Zero))
            {
                Return (Zero)
            }

            SGPO (HRE0, HRG0, HRA0, One)
            SGPO (PWE0, PWG0, PWA0, One)
            Sleep (DLPW)
            SGPO (HRE0, HRG0, HRA0, Zero)
            Sleep (DLHR)
            LREN = LTRE /* External reference */
            CEDR = One
            LNKD = Zero
            While ((LNKS < 0x07))
            {
                Sleep (One)
            }

            SVID = HVID /* \_SB_.PCI0.RP01.PEGP.HVID */
            SDID = HDID /* \_SB_.PCI0.RP01.PEGP.HDID */
            LCTL = ((ELCT & 0x43) | (LCTL & 0xFFBC))
            \_SB.PCI0.RP01.PEGA.LCT1 = ((ELCT & 0x43) | (\_SB.PCI0.RP01.PEGA.LCT1 & 0xFFBC))
            Return (Zero)
        }

        Method (HGOF, 0, Serialized)
        {
            If ((SGGP != One))
            {
                Return (Zero)
            }

            If ((CCHK (Zero) == Zero))
            {
                Return (Zero)
            }

            ELCT = LCTL /* \_SB_.PCI0.RP01.PEGP.LCTL */
            HVID = SVID /* \_SB_.PCI0.RP01.PEGP.SVID */
            HDID = SDID /* \_SB_.PCI0.RP01.PEGP.SDID */
            LTRE = LREN /* \_SB_.PCI0.RP01.LREN */
            LNKD = One
            While ((LNKS != Zero))
            {
                Sleep (One)
            }

            SGPO (HRE0, HRG0, HRA0, One)
            SGPO (PWE0, PWG0, PWA0, Zero)
            Return (Zero)
        }

        Method (SGST, 0, Serialized)
        {
            If ((SGMD & 0x0F))
            {
                If ((SGGP != One))
                {
                    Return (0x0F)
                }

                If ((DVID != 0xFFFF))
                {
                    If ((CBCC == 0x03))
                    {
                        Return (0x0F)
                    }
                }

                Return (Zero)
            }

            If ((DVID != 0xFFFF))
            {
                Return (0x0F)
            }

            Return (Zero)
        }

        Method (SGPO, 4, Serialized)
        {
            If ((Arg2 == Zero))
            {
                Arg3 = ~Arg3
                Arg3 &= One
            }

            If ((SGGP == One))
            {
                If (CondRefOf (\_SB.SGOV))
                {
                    \_SB.SGOV (Arg1, Arg3)
                }
            }
        }

        Method (SGPI, 4, Serialized)
        {
            If ((Arg0 == One))
            {
                If (CondRefOf (\_SB.GGOV))
                {
                    Arg2 = \_SB.GGOV /* External reference */
                    Local0
                }
            }

            If ((Arg3 == Zero))
            {
                Local0 = ~Local0
                Local0 &= One
            }

            Return (Local0)
        }

        Method (CCHK, 1, NotSerialized)
        {
            If ((PVID == IVID))
            {
                Return (Zero)
            }

            If ((Arg0 == Zero))
            {
                If ((SGPI (SGGP, PWE0, PWG0, PWA0) == Zero))
                {
                    Return (Zero)
                }
            }
            ElseIf ((Arg0 == One))
            {
                If ((SGPI (SGGP, PWE0, PWG0, PWA0) == One))
                {
                    Return (Zero)
                }
            }

            Return (One)
        }
    }
}

